import os
import gobject

class gtp:
	def __init__(self, program, cb):
		(self.infile, self.outfile) = os.popen2(program)
		# register the callback
		self.read_callback_handler = cb

	# transmit a string to program
	def tx(self, what):
		self.infile.write(what + '\n')
		self.infile.flush()

	# receive a string from program
	def rx(self):
		# assumption, no newline here
		line = self.outfile.readline()
		if line[0] == '?':
			# there should be another newline here, consume it!
			self.outfile.readline()
			raise RuntimeError(line[2:-1])
		#strip the leading = and the trailing \n
		line = line[2:-1]
		# there should be another newline, or a furthe line of text, check this out!
		line2 = 'x'
		while not line2[0] == '\n':
			line2 = self.outfile.readline()
			if not line2[0] == '\n':
				# concat
				line = line + ' ' + line2[:-1]
		return line

	def name(self):
		self.tx('name')
		prog = self.rx()
		self.tx('version')
		vers = self.rx()
		self.tx('protocol_version')
		pvers = self.rx()
		return prog + ' ' + vers 

	def setBoardsize(self, size):
		self.tx('boardsize ' + str(size))
		self.rx()

	def clearBoard(self):
		self.tx('clear_board')
		self.rx()
	
	def setKomi(self, komi):
		self.tx('komi ' + str(komi))
		self.rx()
	
	def setHandicap(self, hcp):
		if hcp < 2:
			return None
		self.tx('fixed_handicap ' + str(hcp))
		return self.rx()

	def move(self, color, vertex):
		self.tx('play ' + color + ' ' + vertex)
		self.rx()

	def passmove(self, color):
		self.tx('play ' + color + ' pass')
		self.rx()

	def finalScore(self):
		self.tx('final_score')
		return self.rx()
	
	def level(self, level):
		self.tx('level ' + str(level))
		return self.rx()

	# don't block the whole GUI while GnuGO is thinking!
	def genmove(self, color):
		self.tx('genmove ' + color)
		gobject.io_add_watch(self.outfile, gobject.IO_IN, self.read_callback_handler)
		#return self.rx()
	def genmove_blocking(self, color):
		self.tx('genmove ' + color)
		return self.rx()
	def listStones(self, color):
		self.tx('list_stones ' + color)
		return self.rx()
	def finalStatus(self, which):
		self.tx('final_status_list ' + which)
		return self.rx()
	def getCaptures(self, color):
		self.tx('captures ' + color)
		return self.rx()
	def undo(self):
		self.tx('undo')
		self.rx()
	
	# load/save from/to file in sgf format
	def save(self, filename):
		self.tx('printsgf ' + filename)
		self.rx()
	def load(self, filename):
		self.tx('loadsgf ' + filename)
		return self.rx()
	def getBoardsize(self):
		self.tx('query_boardsize')
		return self.rx()
	def getKomi(self):
		self.tx('get_komi')
		return self.rx()
	def getMoveHistory(self):
		self.tx('move_history')
		return self.rx()
